function RaceTimer() {

}

RaceTimer.prototype.current_checkpoint = 1;
RaceTimer.prototype.current_race_name = "";
RaceTimer.prototype.current_race_id = "";
RaceTimer.prototype.current_race_type = "";
RaceTimer.prototype.current_vehicle_name = "";
RaceTimer.prototype.max_checkpoints = -1;
RaceTimer.prototype.num_laps = 0;
RaceTimer.prototype.current_lap = 0;
RaceTimer.prototype.start_time = 0;

var self;

RaceTimer.prototype.initialize = function() {

	self = this;

	if (self.persistance.times == undefined) {
		self.persistance.times = {};
	}

	if(this.persistance.driver_name === undefined){
        this.persistance.driver_name = "default_name";
    }

    console.log("initialization - submit times? " + this.persistance.submit_times);
    if(this.persistance.submit_times === undefined){
        this.persistance.submit_times = false;
    }

    $(".RaceTimer").load("apps/RaceTimer/app.html", function() {
    	timer_show();

   		$(".RaceTimer").resize(stupidResizeFix);

   		 stupidResizeFix();

		//$("#bestLapTime").html("Waiting...");


   		 $("#settings_close").hide();
   		 $("#settings_open").click(function() {

   		 	$("#settings_open").hide();
   		 	$("#settings_close").show();

   		 	$("#console").load("apps/RaceTimer/settings.html", function() {
   		 		$("#driver_name").val(self.persistance.driver_name);
   		 		if (self.persistance.submit_times == true){
		   				$('#submit_times').prop('checked', true);
		   			} else {
						$('#submit_times').prop('checked', false);
		   			}

	   		 	$("#save_name").click(function() {
	   		 		console.log("setting name to: " + $("#driver_name").val());
	   		 		self.persistance.driver_name = $("#driver_name").val();
	   		 		self.save();
	   			});

		   		$("#submit_times").click(function() {
		   			self.persistance.submit_times = $(this).is(":checked")
		   			console.log("submit times? : " + self.persistance.submit_times);
		   			self.save();
		   		});
   		 	});
   		 })

   		$("#settings_close").click(function() {
   		 	$("#settings_close").hide();
   		 	$("#settings_open").show();
   		 	$("#console").html("");
   		 })
    } );

    this.current_checkpoint = 1;
    this.current_race_name = "";
    this.current_race_id = "";
    this.current_race_type = "";
    this.current_vehicle_name = "";
    this.max_checkpoints = -1;
    this.current_lap = 0;
    this.num_laps = 0;
    this.start_time = 0;
};

function stupidResizeFix() {
	var table_height = $(".lapTimerTable").height();
	var racetimer_height = $(".RaceTimer").height();

	$("#console").height(racetimer_height - table_height - 25);
}

RaceTimer.prototype.update = function(streams) {

};

RaceTimer.prototype.softReset = function() {
    this.current_checkpoint = 1;
    this.current_race_id = "";
    this.current_race_type = "";
    this.max_checkpoints = -1;
    this.current_lap = 0;
    this.num_laps = 0;
    this.start_time = 0;
}

RaceTimer.prototype.resetRace = function(clear_timer, show_msg) {
	if (this.current_race_id == "") {
		return; // no race in progress, no need to reset
	}

	if (typeof clear_timer == "undefined") {
		clear_timer = true;
	}

	console.log("resetting race");
	
	if (clear_timer) {
		timer_reset();
	}

	if (typeof show_msg == "undefined") {
		show_msg = true;
	}

	if (show_msg) {
		RaceTimer.prototype.writeStatus("Race reset.");
	}

    this.current_checkpoint = 1;
    this.current_race_name = "";
    this.current_race_id = "";
    this.current_vehicle_name = "";
    this.current_race_type = "";
    this.max_checkpoints = -1;
    this.current_lap = 0;
    this.num_laps = 0;
    this.start_time = 0;
}
/*
	global checks for:
	- error checking for num checkpoints/race id/race type
	- is this checkpoint part of the current race?
	- is this checkpoint our current target?
*/
RaceTimer.prototype.onCheckpointHit = function(race_id, num, is_finish) {

	if (num != this.current_checkpoint) {
		console.log("not our target checkpoint");
		return;
	}

	if (this.current_race_id == "") {
		RaceTimer.prototype.writeStatus("ERROR: race id value not set by race creator");
		return;
	}

	if (this.max_checkpoints == -1) {
		RaceTimer.prototype.writeStatus("ERROR: maximum checkpoint value not set by race creator");
		return;
	}

	if (this.current_race_type == "") {
		RaceTimer.prototype.writeStatus("ERROR: race type not set by race creator");
		return;
	}

	if (race_id != this.current_race_id) {
		console.log("not a checkpoint of this race");
		return;
	}

	if (typeof is_finish == "undefined") {
		is_finish = false;
	}

	if (this.current_race_type == "sprint") {
		this.sprintCheckpointHit(num, is_finish)
	} else if (type == "hotlap") {
		this.hotlapCheckpointHit(num, is_finish)
	} else if (type == "circuit") {
		this.circuitCheckpointHit(num, is_finish)
	}
};

// each type of checkpoint hit must increment the current_checkpoint

RaceTimer.prototype.writeStatus = function(str) {
	$("#console").append(str + "<br/>");
	$("#console").animate({ scrollTop: $("#console")[0].scrollHeight}, 1000);
}

RaceTimer.prototype.circuitCheckpointHit = function(num, is_finish) {

}

RaceTimer.prototype.hotlapCheckpointHit = function(num, is_finish) {

}

RaceTimer.prototype.sprintCheckpointHit = function(num, is_finish) {
	var time = Date.now();
	var time_diff = time - this.start_time;
	var time_str = formatTime(time_diff);

	if (num == 1 && this.current_checkpoint == 1) {
		this.startRace();
		this.writeStatus("[Sprint] Race Started");
	} else {
		this.writeStatus("[Sprint] Zone " + (num-1) + ": " + time_str);
	}

	if (is_finish) {
		RaceTimer.prototype.softReset();
		this.endRace(time_diff, time_str);
	} else {
		this.current_checkpoint = this.current_checkpoint+1;
	    console.log("next checkpoint: " + this.current_checkpoint);
	}
}


RaceTimer.prototype.startRace = function() {
	timer_reset();
	timer_show();
    timer_start();
    this.start_time = Date.now();


    callLuaFuncCallback("v.vehicleDirectory", function(result) {		
	    var getVehicleNameCode = "function readVehicleName(%path) { %fileReader = new FileObject(); %fileReader.openForRead(%path); %name = %fileReader.readLine(); %fileReader.close(); return %name; }";

	    executeGameEngineCode(getVehicleNameCode);

		callGameEngineFuncCallback("readVehicleName(\""+result+"name.cs\")", function(result) {
			var car_name = result.substring(result.indexOf('"')+1,result.lastIndexOf('"'));
			RaceTimer.prototype.current_vehicle_name = car_name;

			if (self.persistance.times[RaceTimer.prototype.current_race_name] == undefined) {
				self.persistance.times[RaceTimer.prototype.current_race_name] = {};
			}

			if (self.persistance.times[RaceTimer.prototype.current_race_name][car_name] == undefined) {
				$("#bestLapTime").html("None!");
			} else {
				$("#bestLapTime").html(formatTime(self.persistance.times[RaceTimer.prototype.current_race_name][car_name]));
			}
	
		});
    });
}


RaceTimer.prototype.endRace = function(time, time_str) {
	console.log("attempting to end race...");
	callLuaFuncCallback("v.vehicleDirectory", function(result) {		
	    var getVehicleNameCode = "function readVehicleName(%path) { %fileReader = new FileObject(); %fileReader.openForRead(%path); %name = %fileReader.readLine(); %fileReader.close(); return %name; }";

	    executeGameEngineCode(getVehicleNameCode);

	    console.log("attempting to read car name...");
		callGameEngineFuncCallback("readVehicleName(\""+result+"name.cs\")", function(result) {
			var car_name =  result.substring(result.indexOf('"')+1,result.lastIndexOf('"'));
			if( car_name == RaceTimer.prototype.current_vehicle_name) {	// check that start vehicle is the same as the end vehicle

				console.log("vehicle name read: " + car_name);
				timer_stop();
				timer_manual_update(time_str);
				RaceTimer.prototype.writeStatus("Race over. Final Time: " + time_str);


				// check for / save best time in persistance
				if (self.persistance.times[RaceTimer.prototype.current_race_name][car_name] == undefined) {
					self.persistance.times[RaceTimer.prototype.current_race_name][car_name] = time;
					self.save();

					$("#bestLapTime").html(formatTime(self.persistance.times[RaceTimer.prototype.current_race_name][car_name]));
				} else if (time < self.persistance.times[RaceTimer.prototype.current_race_name][car_name]) {
					console.log("saving NEW best time...");
					self.persistance.times[RaceTimer.prototype.current_race_name][car_name] = time;
					self.save();

					$("#bestLapTime").html(formatTime(self.persistance.times[RaceTimer.prototype.current_race_name][car_name]));
				}


				if (self.persistance.submit_times == true) {
					RaceTimer.prototype.writeStatus("Submitting time to server...");
					post_time(time, function() {
						RaceTimer.prototype.resetRace(false, false);
					});
				} else {
					console.log("Time not submitted");
					RaceTimer.prototype.resetRace(false, false);
				}

			} else {
				console.log("failed car name check: " + car_name + " != " + this.current_vehicle_name);
			}
		});
    });
}

// websocket stuff
function post_time(time, callback) { 
	console.log("attempting to connect to websocket...");
	var websocket = new WebSocket("ws://192.168.1.2:4567/post_time"); 

	websocket.onopen = function() {
		console.log('Connected to laptime thingy');
        msg = {
          type: "new_time",
          driver: self.persistance.driver_name,
          car: RaceTimer.prototype.current_vehicle_name,
          track: "TODO",
          race: RaceTimer.prototype.current_race_name,
          time: time
        }

        websocket.send(JSON.stringify(msg));
        console.log("sent laptime!");
        websocket.close();
        callback();
	}

	websocket.onclose = function(ev) {
		console.log('Disconnected');
	};

	websocket.onmessage = function(ev) {
		// receive rank that this laptime ended up then callback

		websocket.close();
        callback();
	};

	websocket.onerror = function(ev) { 
		console.log('Error');
		callback();
	};
}

// stolen from the internet, works well
var	clsStopwatch = function() {
	// Private vars
	var	startAt	= 0;	// Time of last start / resume. (0 if not running)
	var	lapTime	= 0;	// Time on the clock when last stopped in milliseconds

	var	now	= function() {
			return (new Date()).getTime(); 
		}; 

	// Public methods
	// Start or resume
	this.start = function() {
			startAt	= startAt ? startAt : now();
		};

	// Stop or pause
	this.stop = function() {
			// If running, update elapsed time otherwise keep it
			lapTime	= startAt ? lapTime + now() - startAt : lapTime;
			startAt	= 0; // Paused
		};

	// Reset
	this.reset = function() {
			lapTime = startAt = 0;
		};

	// Duration
	this.time = function() {
			return lapTime + (startAt ? now() - startAt : 0); 
		};
};

var x = new clsStopwatch();
var $time;
var clocktimer;

function pad(num, size) {
	var s = "0000" + num;
	return s.substr(s.length - size);
}

function formatTime(time) {
	var h = m = s = ms = 0;
	var newTime = '';

	h = Math.floor( time / (60 * 60 * 1000) );
	time = time % (60 * 60 * 1000);
	m = Math.floor( time / (60 * 1000) );
	time = time % (60 * 1000);
	s = Math.floor( time / 1000 );
	ms = time % 1000;

	//newTime = pad(h, 2) + ':' + pad(m, 2) + ':' + pad(s, 2) + ':' + pad(ms, 3);
	newTime = pad(m, 2) + ':' + pad(s, 2) + ':' + pad(ms, 3);
	return newTime;
}

function timer_show() {
	$time = document.getElementById('time');
	timer_update();
}

function timer_update() {
	$time.innerHTML = formatTime(x.time());
}

//hackfix
function timer_manual_update(time_str) {
	$time.innerHTML = time_str;
}

function timer_start() {
	clocktimer = setInterval("timer_update()", 1);
	x.start();
}

function timer_stop() {
	x.stop();
	clearInterval(clocktimer);
}

function timer_reset() {
	timer_stop();
	x.reset();
	timer_update();
}